﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Apache.NMS;

namespace JmsClient
{
    class Program
    {
        private static ISession session;
        private static string hostname = "localhost";
        private static int port = 61613;        
        private static string username = "user";
        private static string password = "pass";

        private static string queue = "queue://samplequeue";

        static void Main(string[] args)
        {
            Uri connectUri = new Uri("stomp:tcp://" + hostname + ":" + port);          
            
            IConnectionFactory factory = new NMSConnectionFactory(connectUri);


            using (IConnection connection = factory.CreateConnection(username,password))
            using (session = connection.CreateSession())
            {
                IDestination destination = session.GetDestination(queue);
                
                using (IMessageProducer producer = session.CreateProducer(destination))
                using (IMessageConsumer consumer = session.CreateConsumer(destination))
                {
                    //make sure acknowledgementmode is what we expect it to be:
                    connection.AcknowledgementMode = AcknowledgementMode.AutoAcknowledge;
                    connection.Start();

                    ITextMessage request = session.CreateTextMessage();                    
                    request.Text="Testing one two three!";
                    producer.Send(request);

                    //This is commented but also works instead of consumer.Receive()
                    //consumer.Listener += new MessageListener(OnMessage);
                    //Console.WriteLine("Consumer started, waiting for messages... (Press ENTER to stop.)");
                    
                    ITextMessage message = (ITextMessage)consumer.Receive();
                    Console.WriteLine("Received message with text: " + message.Text);

                    Console.ReadLine();
                    consumer.Close();
                    session.Close();
                    connection.Close();
                }
            }
        }


        private static void OnMessage(IMessage message)
        {
            Console.WriteLine("Message received");

            ITextMessage msg = (ITextMessage)message;

            Console.WriteLine(msg.Text);
        }
    }
}
